//////////////////////////////////////////////////////////////////////////////
// NAME.......: MaxInterface.CPP                                               
// PURPOSE....: Maximizer OLE Automation classes Application and CurrentRecord created 
//              from Maximizer Type Library 4.0 (MaxWin.tlb).
// WRITTEN....: 96/09/27 by Darko Juvan
// DESCRIPTION: Machine generated IDispatch wrapper class(es) created with ClassWizard
//
// This code and information is provided "as is" without warranty of any
// kind, either expressed or implied, including but not limited to the
// implied warranties of merchantability and/or fitness for a particular
// purpose..
//
// Copyright (c) 1998  Multiactive Software Inc.  All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "maxinterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// IMaxApp properties

/////////////////////////////////////////////////////////////////////////////
// IMaxApp operations

CString IMaxApp::GetActiveWindow()
{
	CString result;
	InvokeHelper(0x1, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
	return result;
}

CString IMaxApp::GetCurrentDBPath()
{
	CString result;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
	return result;
}

CString IMaxApp::GetCurrentUser()
{
	CString result;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
	return result;
}

BOOL IMaxApp::GetBusyIndicator()
{
	BOOL result;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL IMaxApp::GetSecurityStatus()
{
	BOOL result;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

CString IMaxApp::GetDatabaseList()
{
	CString result;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
	return result;
}

CString IMaxApp::GetVisibilityState()
{
	CString result;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
	return result;
}

void IMaxApp::SetVisibilityState(LPCTSTR VisibleState)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 VisibleState);
}

void IMaxApp::OpenDatabase(LPCTSTR command, const VARIANT& description, const VARIANT& path, const VARIANT& userid, const VARIANT& password)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 command, &description, &path, &userid, &password);
}

void IMaxApp::AddNewCategory(LPCTSTR type1, LPCTSTR type2, LPCTSTR text, const VARIANT& attribute1, const VARIANT& attribute2, const VARIANT& attribute3, const VARIANT& attribute4, const VARIANT& attribute5)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type1, type2, text, &attribute1, &attribute2, &attribute3, &attribute4, &attribute5);
}

void IMaxApp::MakeMarkedListActive()
{
	InvokeHelper(0xb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void IMaxApp::ActivateWindow(LPCTSTR window)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 window);
}

void IMaxApp::CreateListToFile(LPCTSTR type, LPCTSTR filename)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR;
	InvokeHelper(0xd, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, filename);
}

void IMaxApp::CatalogList(LPCTSTR type, const VARIANT& catalog, const VARIANT& filename, const VARIANT& condition1, const VARIANT& condition2)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0xe, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, &catalog, &filename, &condition1, &condition2);
}

void IMaxApp::ListOfCategories(LPCTSTR type, const VARIANT& table, const VARIANT& filename)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0xf, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, &table, &filename);
}

void IMaxApp::SetAlarm(LPCTSTR condition)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x10, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 condition);
}

void IMaxApp::SetCloseAlert(short condition, const VARIANT& text)
{
	static BYTE parms[] =
		VTS_I2 VTS_VARIANT;
	InvokeHelper(0x11, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 condition, &text);
}

void IMaxApp::RunMacro(LPCTSTR description, const VARIANT& count)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT;
	InvokeHelper(0x12, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 description, &count);
}

void IMaxApp::StartEditor()
{
	InvokeHelper(0x13, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void IMaxApp::ShowBuildListDlg(BOOL condition)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 condition);
}

LPDISPATCH IMaxApp::GetCurrentRecordObject()
{
	LPDISPATCH result;
	InvokeHelper(0x15, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, NULL);
	return result;
}

void IMaxApp::CloseDatabase()
{
	InvokeHelper(0x16, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// ICurrentRec properties

/////////////////////////////////////////////////////////////////////////////
// ICurrentRec operations

LPDISPATCH ICurrentRec::GetApplicationObject()
{
	LPDISPATCH result;
	InvokeHelper(0x1, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, NULL);
	return result;
}

long ICurrentRec::GetListCount()
{
	long result;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void ICurrentRec::SetFieldValue(LPCTSTR field, LPCTSTR value)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 field, value);
}

void ICurrentRec::AddNote(LPCTSTR text)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 text);
}

void ICurrentRec::AddMailMergeNote(LPCTSTR text)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 text);
}

void ICurrentRec::AddPhoneCallNote(LPCTSTR text)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 text);
}

void ICurrentRec::AddTimedNote(LPCTSTR text)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 text);
}

void ICurrentRec::AddMaxMergeNote(LPCTSTR text)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 text);
}

CString ICurrentRec::GetFieldValue(LPCTSTR field)
{
	CString result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		field);
	return result;
}

BOOL ICurrentRec::IsRecordMarked()
{
	BOOL result;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void ICurrentRec::Dial(LPCTSTR type, const VARIANT& string)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT;
	InvokeHelper(0xb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, &string);
}

void ICurrentRec::ExecuteUpdate(BOOL condition)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 condition);
}

void ICurrentRec::InitAndCreateRecord(LPCTSTR type, LPCTSTR name, const VARIANT& id, const VARIANT& address)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0xd, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, name, &id, &address);
}

void ICurrentRec::AddAppointment(LPCTSTR date, LPCTSTR time1, LPCTSTR time2, LPCTSTR text, const VARIANT& personal, const VARIANT& alarm, const VARIANT& alarm_time, const VARIANT& iconType, const VARIANT& priority, const VARIANT& completed)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0xe, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 date, time1, time2, text, &personal, &alarm, &alarm_time, &iconType, &priority, &completed);
}

void ICurrentRec::AddHotListTask(LPCTSTR date, LPCTSTR time, LPCTSTR text, const VARIANT& personal, const VARIANT& iconType, const VARIANT& priority, const VARIANT& completed)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0xf, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 date, time, text, &personal, &iconType, &priority, &completed);
}

void ICurrentRec::AddNoteFromClipboard(LPCTSTR type)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x10, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type);
}

void ICurrentRec::AddOLEDocument(LPCTSTR type, const VARIANT& filename, const VARIANT& description, const VARIANT& pub, const VARIANT& activate, const VARIANT& disp_as_icon, const VARIANT& link)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x11, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, &filename, &description, &pub, &activate, &disp_as_icon, &link);
}

void ICurrentRec::ListAll(LPCTSTR type)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x12, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type);
}

void ICurrentRec::MarkRecord(LPCTSTR type)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x13, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type);
}

void ICurrentRec::RefreshWindows(BOOL condition)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 condition);
}

void ICurrentRec::ScrollList(LPCTSTR direction)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x15, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 direction);
}

void ICurrentRec::SetCategoryDelimiter(LPCTSTR delimiter)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x16, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 delimiter);
}

void ICurrentRec::SetListColumns(LPCTSTR description)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x17, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 description);
}

void ICurrentRec::SetUpdateMode(LPCTSTR condition)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x18, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 condition);
}

void ICurrentRec::SortOnColumn(short column)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x19, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 column);
}

void ICurrentRec::StartDocument()
{
	InvokeHelper(0x1a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void ICurrentRec::Transfer(LPCTSTR type, const VARIANT& db_description, const VARIANT& db_path, const VARIANT& userid, const VARIANT& password, const VARIANT& udf, const VARIANT& document, const VARIANT& notes, const VARIANT& appointments, 
		const VARIANT& text, const VARIANT& history, const VARIANT& duplicates, const VARIANT& use_modify_flag, const VARIANT& reset_modify_flag, const VARIANT& result_filename)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x1b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, &db_description, &db_path, &userid, &password, &udf, &document, &notes, &appointments, &text, &history, &duplicates, &use_modify_flag, &reset_modify_flag, &result_filename);
}

void ICurrentRec::UndoSearch()
{
	InvokeHelper(0x1c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void ICurrentRec::SearchByClientID(LPCTSTR search_string, const VARIANT& contactNo, const VARIANT& condition)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x1d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 search_string, &contactNo, &condition);
}

void ICurrentRec::SearchByLastName(LPCTSTR search_string, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x1e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 search_string, &condition1, &condition2, &condition3);
}

void ICurrentRec::SearchByFirstName(LPCTSTR search_string, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x1f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 search_string, &condition1, &condition2, &condition3);
}

void ICurrentRec::SearchByPosition(LPCTSTR search_string, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x20, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 search_string, &condition1, &condition2, &condition3);
}

void ICurrentRec::SearchByCompany(LPCTSTR type, LPCTSTR search_string, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3, const VARIANT& condition4)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x21, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, search_string, &condition1, &condition2, &condition3, &condition4);
}

void ICurrentRec::SearchByAddress(LPCTSTR type, LPCTSTR search_string, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3, const VARIANT& condition4)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x22, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 type, search_string, &condition1, &condition2, &condition3, &condition4);
}

void ICurrentRec::SearchByPhone(short phoneNo, LPCTSTR search_string, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3, const VARIANT& condition4)
{
	static BYTE parms[] =
		VTS_I2 VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x23, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 phoneNo, search_string, &condition1, &condition2, &condition3, &condition4);
}

void ICurrentRec::SearchByLastChangeDate(LPCTSTR start_date, LPCTSTR end_date, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3, const VARIANT& condition4)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x24, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 start_date, end_date, &condition1, &condition2, &condition3, &condition4);
}

void ICurrentRec::SearchByCategories(LPCTSTR udf_name, LPCTSTR search_string1, const VARIANT& search_string2, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3, const VARIANT& condition4, const VARIANT& condition5)
{
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x25, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 udf_name, search_string1, &search_string2, &condition1, &condition2, &condition3, &condition4, &condition5);
}

void ICurrentRec::SearchByNotes(LPCTSTR search_string, const VARIANT& start_date, const VARIANT& end_date, const VARIANT& condition1, const VARIANT& condition2, const VARIANT& condition3, const VARIANT& condition4, const VARIANT& condition5)
{
	static BYTE parms[] =
		VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
	InvokeHelper(0x26, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 search_string, &start_date, &end_date, &condition1, &condition2, &condition3, &condition4, &condition5);
}
